# Unsupervised Paraphrasing under Syntax Knowledge

Codes for AAAI-23 paper *Unsupervised Paraphrasing under Syntax Knowledge*.

## Environment

All the experiments were conduct on `python3.9` with libraries specified in `requirements.txt`

## Data

Datasets will be acquired automatically with `datasets` lib. No manual download needed.

The pretrained word composable knowledge network weights are under the `Data` directory.
It is trained with [glove.42B.300d](https://nlp.stanford.edu/projects/glove/) as the word representations.

The actual codes for training the word composable knowledge cannot be shared currently due to an extended version of
word composable knowledge is still under review.
Sample codes for the loss functions used to train the networks used in this work are provided instead.

## Training and evaluation

* `text_main.py` is for pretrainning the text auto encoder.
* `unsup_main.py` is for training the paraphrase generator.

Sample configurations are under `Conf` directory. Run the (pre)training process by
command `python {text,unsup}_main.py -c Conf/sample_conf`.

Predictions of our model are generated with `pysyngen.runner.ModelRunner.predict()` and then evaluated
by `pysyngen.evaluator.MultiPredictionEvaluator`.
Evaluations on the compared methods can be done by converting their predictions to the same format.
