import os

import torch

from pysyngen.data.vocab import build_spl_token_list, build_vocab_from_word_list, build_vocab_from_dataset

os.chdir('..')

semvec = 'Data/semvec/glove.42B.300d.txt'
name = 'glove42B'
num_unk = 1

spl_list = build_spl_token_list(num_unk)
build_vocab_from_word_list(semvec, spl_list, name)
build_vocab_from_word_list('Data/vocab/rel_idx_ent_ud.txt', name ='relvocab')

ref_voc = torch.load('Data/vocab/glove42B_unk1.pt')

build_vocab_from_dataset('WikiText-103', columns=['text'], sp_token=spl_list,
                         save_name='wiki103_f10_g42B', vocab_freq=10,
                         we_vocab=ref_voc, we_name='glove42B')
